<template>
  <ObForm
    @submit="onSubmit"
    :form-data="formData"
    :form-model="formModel"
    :is-show-controls="isLoaded"
    :is-read-only="isRegistered"
    :is-submit-disabled="submitButtonState"
    ok-text="Добавить"
    cancel-text="Отменить"
  >
    <ObLoader
      v-if="!isLoaded"
      class="modal-loader"
    />

    <template v-else-if="formData.props">
      <OwnerField @input="changeOwner" />

      <div class="bottom-30">
        <ObSelect
          :required="true"
          :is-search="true"
          :items="countries"
          :is-auto-complete="false"
          v-model="formData.countryCode"
          label="Страна регистрации"
          value-exp="countryCode"
          display-exp="titleWording"
          class="bottom-20"
        />

        <ObCheckbox
          v-model="isGovernmentRegnum"
          label="Госномер РФ"
          class="bottom-10"
        />

        <div class="inputs-group">
          <ObInput
            v-model="formData.props.regnum"
            :mask="isGovernmentRegnum ? regnumMask : ''"
            :required="true"
            :mask-tokens="regnumMaskTokens"
            property="props.regnum"
            placeholder="Укажите"
            label="Регистрационный номер"
          />

          <ObInput
            label="Макс. грузопод-ть"
            placeholder="20"
            sub-title="т"
            type="number:strict"
            property="props.payload_max"
            v-model="formData.props.payload_max"
            :required="true"
            @input="checkLength($event)"
          />
        </div>

        <div
          v-if="!isRegistered"
          class="text-description"
        >
          Марка, цвет, год выпуска и другие данные ТС будут добавлены
          в систему после распознания приложенных документов.
        </div>
      </div>

      <ObAlert
        v-if="isRegistered"
        :hide-close-button="true"
        icon="checked"
        theme="warning"
        text="ТС с таким номером уже зарегистрировано, но не активировано"
      />

      <template v-else>
        <div class="bottom-30">
          <h3 class="subtitle">Право владения</h3>

          <ObControlGroup
            :items="ownershipForms"
            v-model="selectedOwnershipForm"
            theme="light"
            height="slim"
            class="bottom-10"
          />

          <div class="ownership-checkboxes">
            <ObCheckbox
              label="Находится в залоге"
              v-model="formData.props.vehicle_in_pledge"
            />

            <ObCheckbox
              label="ТС застраховано КАСКО"
              v-model="formData.props.has_casco_insurance"
            />
          </div>

          <div
            v-if="selectedOwnershipForm === rentOwnershipFormCode"
            class="rent-scan"
          >
            <div class="uploader-label">
              Загрузите скан договора аренды <span class="-light-raspberry-red">*</span>
            </div>

            <ObUploader
              :upload-method="uploadMethod"
              :upload-options="getUploadOptions()"
              @process-start="onFilesProcessStart"
              @change="onUpload('RENT', $event)"
              class="uploader"
            />
          </div>
        </div>

        <div class="bottom-30">
          <h3 class="subtitle">Трекинг</h3>

          <ObCheckbox
            label="Есть постоянно подключенное бортовое устройство слежения"
            v-model="formData.props.vehicle_with_gps"
            class="bottom-10"
          />

          <ObCheckbox
            label="Готов предоставить полный и постоянный доступ к треку"
            v-model="formData.props.full_access_to_vehicle"
          />
        </div>

        <Documents
          :links="formData.links"
          @upload="onUpload"
        />
      </template>
    </template>
  </ObForm>
</template>

<script>
  import addFormMixin from './mixins/addFormMixin'

  export default {
    name: 'AddResourceTractor',
    mixins: [
      addFormMixin
    ],
    data () {
      return {
        resourceName: 'Tractor'
      }
    },
    computed: {
      formModel () {
        const resultObject = this.commonFormModel

        resultObject.props.nested_fields = Object.assign(this.commonFormModel.props.nested_fields, {
          vehicle_with_gps: {
            value: false
          },
          full_access_to_vehicle: {
            value: false
          }
        })

        return resultObject
      }
    },
    async mounted () {
      await this.getSpeciesUuid()
      await this.getOwnershipForms()

      this.isLoaded = true
    }
  }
</script>

<style lang="scss" scoped>
  @import "./styles/addFormStyles";
</style>